/*	$Id: sw-full-common.h,v 1.3 2008/06/06 18:24:09 rumble Exp $	*/

#ifndef _SW_FULL_COMMON_H
#define _SW_FULL_COMMON_H

#define SMALL_INDEL 1
#define SMALL_DEL 11
#define SMALL_INS 12
#define LARGE_DEL 2
#define INVER 3
#define INVER_FW_OUT 31
#define INVER_FW_IN 32
#define INVER_BW_IN 33
#define INVER_BW_OUT 34
#define SMALL_INVER_FW 35
#define SMALL_INVER_BW 36
#define DUP 4
#define UNSPLIT 5
#define NOT_PRINT 6
#define WORST_SCORE     -9000
struct sw_full_results {
        /* Common fields */
        int read_start;                         /* read index of map */
        int rmapped;                            /* read mapped length */
        int genome_start;                       /* genome index of map (abs) */
        int gmapped;                            /* genome mapped len */
        int matches;                            /* # of matches */
        int mismatches;                         /* # of substitutions */
        int insertions;                         /* # of insertions */
        int deletions;                          /* # of deletions */
        int score;                              /* final SW score */

        char *dbalign;                          /* genome align string */
        char *qralign;                          /* read align string */

        /* Colour space fields */
        int crossovers;                         /* # of mat. xovers */

        bool is_split_align; /*if the alignment is split*/
	int multi_aln;
        int type;
        char *cigar;

};
void reverse_cigar(char *cigar, char *rcigar);
char get_complement_base(char base);
#endif
