#!/usr/bin/python
import string
import sys
#########################################################################################################################
# Extend the XA field of a bwa output sam file. All concordant pairs are removed. Singleton reads and discordant
# reads are kept and extended.
########################################################################################################################
class sam:
	def __init__(self):
		self.sam_line=""
		self.name=""
		self.flag=0
		self.strand=0
		self.unmap=0
		self.chr=""
		self.pos=0
		self.mapq=0
		self.cigar=""
		self.mchr=""
		self.mpos=0
		self.isize=0
		self.seq=""
		self.qval=""
		self.XA=""
		self.difficult=False
		self.is_bad=False
def usage():
	print "%s bwa sam file, output file, discordant pair mapping distance" % sys.argv[0]
def is_concordant(pos1,pos2,strand1,strand2,isize1,con_thresh):
	if (isize1< con_thresh and isize1>0 and strand1==0 and strand2==1)or (isize1>-1*con_thresh and isize1<0 and strand1==1 and strand2==0):
		#print isize1,con_thresh,isize1<con_thresh
		return True
	else:
		return False
def is_difficult(cigar):
	if (cigar.find("I")>=0 or cigar.find("D")>=0 or cigar.find("S")>=0):
		return True
	else:
		return False
def extend_XA(filename,file_out,con_thresh):
	bad_mm_num=3
	f1=open(filename,'r')
	#fout=open(filename+"_extend_difficult","w")
	fout=open(file_out,"w")
	mate1_list=[]
	mate2_list=[]	
	while True:
    		line1 = f1.readline()
		if line1[0:1]=='@':
			continue
    		if len(line1) == 0: # Zero length indicates EOF
        		break
    		line2 = f1.readline()
		if line2[0:1]=='@':
			print "line 2 contains @"
			sys.exit(1)	
    		if len(line2) == 0: # Zero length indicates EOF
			print "odd line num"
			sys.exit(1)	
    		tmp1=line1.split()
		a=sam()
		a.sam_line=line1
		#print "sam line1:%s" % line1
		a.name=tmp1[0]
		a.flag=string.atoi(tmp1[1])
		a.strand=(a.flag & 0x10)/0x10
		a.unmap=(a.flag & 0x04)/0x04
		a.chr=tmp1[2]
		a.pos=string.atoi(tmp1[3])
		a.mapq=string.atoi(tmp1[4])
		a.cigar=tmp1[5]
		a.mchr=tmp1[6]
		a.mpos=string.atoi(tmp1[7])
		a.isize=string.atoi(tmp1[8])
		a.seq=tmp1[9]
		a.qval=tmp1[10]
		a.difficult=is_difficult(a.cigar)

		#mate1_list.append(a)

		tmp2=line2.split()
                b=sam()
                b.sam_line=line2
                b.name=tmp2[0]
		b.flag=string.atoi(tmp2[1])
                b.strand=(b.flag & 0x10)/0x10
		b.unmap=(b.flag & 0x04)/0x04
                b.chr=tmp2[2]
                b.pos=string.atoi(tmp2[3])
                b.mapq=string.atoi(tmp2[4])
                b.cigar=tmp2[5]
                b.mchr=tmp2[6]
                b.mpos=string.atoi(tmp2[7])
                b.isize=string.atoi(tmp2[8])
                b.seq=tmp2[9]
                b.qval=tmp2[10]
		b.difficult=is_difficult(b.cigar)
		for i in range(11,len(tmp1)):
                        if (tmp1[i].find('NM:'))>=0:
                                if string.atoi(tmp1[i][5:])>bad_mm_num:
						a.difficult = True
                                        #a.unmap=True
		for i in range(11,len(tmp2)):
                	if (tmp2[i].find('NM:'))>=0:
                                if string.atoi(tmp2[i][5:])>bad_mm_num:
					b.difficult = True
                                        #b.unmap=True;

		mate1_list.append(a)
                mate2_list.append(b)

		if a.name != b.name:
			print "file not in pair."
			sys.exit(1);
		#is_concordant(pos1,pos2,strand1,strand2,isize1,con_thresh)
		if (a.unmap and b.unmap):
			mate1_list=[]
                        mate2_list=[]
                        continue
		if (not a.is_bad and not b.is_bad) and is_concordant(a.pos,b.pos,a.strand,b.strand,a.isize,con_thresh):
			if a.difficult==True or b.difficult==True:
				fout.write(line1)	
				fout.write(line2)	
			#print a.name, "is concordant:",a.isize
			mate1_list=[]
			mate2_list=[]
			continue
		#print "sam line2:%s" % b.sam_line
		#print "b name:%s" % b.name
		#print "b flag:%s" % b.flag
		#print "b chr:%s" % b.chr
		#print "b pos:%s" % b.pos
		#print "b mapq:%s" % b.mapq
		#print "b cigar:%s" % b.cigar
		#print "b mchr:%s" % b.mchr
		#print "b mpos:%s" % b.mpos
		#print "b isize:%s" % b.isize
		#print "b seq:%s" % b.seq
		#print "b qval:%s" % b.qval
		

		x0_num_a=0
		x0_num_b=0
		for i in range(11,len(tmp1)):
			if (tmp1[i].find('X0'))>=0:
				x0_num_a=string.atoi(tmp1[i][5:])-1
				break
		
		for i in range(11,len(tmp2)):
			if (tmp2[i].find('X0'))>=0:
                                x0_num_b=string.atoi(tmp2[i][5:])-1
                                break

		#print x0_num_a
		#print x0_num_b
		for i in range(11,len(tmp1)):
			if (tmp1[i].find('XA'))>=0:
				#print "tmp1 find:%s" % tmp1[i].find("XA")
				#print "tmp1:%s" % tmp1[i]
				tmp_xa1=tmp1[i][5:].split(";")

				#for j in range(0,len(tmp_xa1)):
				for j in range(0,x0_num_a):
					if len(tmp_xa1[j])>0:
						tmp_xa2=tmp_xa1[j].split(",")
						#print "xa1:%s" % tmp_xa1[j]
						#print "xa2:%s" % tmp_xa2[0]
				                #print "xa2:%s" % tmp_xa2[1]
        	        			#print "xa2:%s" % tmp_xa2[2] 
						c=sam()
						if tmp_xa2[1][0:1]=="+":
							c.strand=0
						else :
							c.strand=1
						c.chr=tmp_xa2[0]
						c.pos=string.atoi(tmp_xa2[1][1:])
						c.cigar=tmp_xa2[2]
						mate1_list.append(c)	
				
				break;
		for i in range(11,len(tmp2)):
                	if (tmp2[i].find('XA'))>=0:
                                #print "tmp2 find:%s" % tmp2[i].find("XA")
                                #print "tmp2:%s" % tmp2[i]
                                tmp_xa1=tmp2[i][5:].split(";")

                                #for j in range(0,len(tmp_xa1)):
                                for j in range(0,x0_num_b):
                                        if len(tmp_xa1[j])>0:
                                                tmp_xa2=tmp_xa1[j].split(",")
                                                #print "xa1:%s" % tmp_xa1[j]
                                                #print "xa2:%s" % tmp_xa2[0]
                                                #print "xa2:%s" % tmp_xa2[1]
                                                #print "xa2:%s" % tmp_xa2[2]
                                                c=sam()
                                                if tmp_xa2[1][0:1]=="+":
                                                        c.strand=0
                                                else :
                                                        c.strand=1
                                                c.chr=tmp_xa2[0]
                                                c.pos=string.atoi(tmp_xa2[1][1:])
                                                c.cigar=tmp_xa2[2]
                                                mate2_list.append(c)

                                break;
		#print "mate1"
		#print a.unmap
		#print b.unmap
		#print  "len(mate1_list):%i" % len(mate1_list)
		#print  "len(mate2_list):%i" % len(mate2_list)
		buffer=[]
		is_con=False
		for i in range(0,len(mate1_list)):		
			for j in range (0,len(mate2_list)):
				#print "flag1,flag2:%s,%s" % (mate1_list[i].flag,mate2_list[i].flag)
				if a.is_bad:
                                        d=mate1_list[i]
                                        e=mate2_list[j]

                                        fout.write(a.name+"\t")
                                        fout.write(str(a.flag)+"\t")
                                        fout.write(e.chr+"\t")
                                        fout.write(str(e.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(d.cigar+"\t")
                                        fout.write("=\t")
                                        fout.write(str(e.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(a.seq+"\t")
                                        fout.write(a.qval+"\n")

                                        fout.write(b.name+"\t")
                                        fout.write(str(b.flag)+"\t")
                                        fout.write(e.chr+"\t")
                                        fout.write(str(e.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(e.cigar+"\t")
                                        fout.write("=\t")
                                        fout.write(str(e.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(b.seq+"\t")
                                        fout.write(b.qval+"\n")
				elif b.is_bad:
					d=mate1_list[i]
                                        e=mate2_list[j]

                                        fout.write(a.name+"\t")
                                        fout.write(str(a.flag)+"\t")
                                        fout.write(d.chr+"\t")
                                        fout.write(str(d.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(d.cigar+"\t")
                                        fout.write("=\t")
                                        fout.write(str(d.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(a.seq+"\t")
                                        fout.write(a.qval+"\n")

                                        fout.write(b.name+"\t")
                                        fout.write(str(b.flag)+"\t")
                                        fout.write(d.chr+"\t")
                                        fout.write(str(d.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(e.cigar+"\t")
                                        fout.write("=\t")
                                        fout.write(str(d.pos)+"\t")
                                        fout.write("0\t")
                                        fout.write(b.seq+"\t")
                                        fout.write(b.qval+"\n")

				elif a.unmap:
					d=mate1_list[i]
				        e=mate2_list[j]
						
					fout.write(a.name+"\t")
					fout.write(str(e.strand*0x20+e.strand*0x10+(a.flag & 0x7CF))+"\t")
					fout.write(e.chr+"\t")
					fout.write(str(e.pos)+"\t")
					fout.write("0\t")
					fout.write(d.cigar+"\t")
					fout.write("=\t")
					fout.write(str(e.pos)+"\t")
					fout.write("0\t")
					fout.write(a.seq+"\t")
					fout.write(a.qval+"\n")
			
					fout.write(b.name+"\t")
        		                fout.write(str(e.strand*0x10+(b.flag & 0x7CF))+"\t")
                		        fout.write(e.chr+"\t")
                        	        fout.write(str(e.pos)+"\t")
	                                fout.write("0\t")
	        	                fout.write(e.cigar+"\t")
        		       	       	fout.write("=\t")
                        		fout.write(str(e.pos)+"\t")
                                	fout.write("0\t")
	                                fout.write(b.seq+"\t")
	        	                fout.write(b.qval+"\n")				

				elif b.unmap:
					d=mate1_list[i]
				        e=mate2_list[j]
						
					fout.write(a.name+"\t")
					fout.write(str(d.strand*0x10+(a.flag & 0x7CF))+"\t")
					fout.write(d.chr+"\t")
					fout.write(str(d.pos)+"\t")
					fout.write("0\t")
					fout.write(d.cigar+"\t")
					fout.write("=\t")
					fout.write(str(d.pos)+"\t")
					fout.write("0\t")
					fout.write(a.seq+"\t")
					fout.write(a.qval+"\n")
			
					fout.write(b.name+"\t")
        		                fout.write(str(d.strand*0x20+d.strand*0x10+(b.flag & 0x7CF))+"\t")
                		        fout.write(d.chr+"\t")
                        	        fout.write(str(d.pos)+"\t")
	                                fout.write("0\t")
	        	                fout.write(e.cigar+"\t")
        		       	       	fout.write("=\t")
                        		fout.write(str(d.pos)+"\t")
                                	fout.write("0\t")
	                                fout.write(b.seq+"\t")
	        	                fout.write(b.qval+"\n")				

				else:
					if mate1_list[i].chr == mate2_list[j].chr:
						d=mate1_list[i]
						e=mate2_list[j]
						#if abs(d.pos - e.pos)<con_thresh:
						if is_concordant(d.pos,e.pos,d.strand,e.strand,d.isize,con_thresh):
							is_con=True
							break
						if d.strand==0:
							pos5_1=d.pos
						else :
							pos5_1=d.pos + len(e.seq)
						if e.strand==0:
							pos5_2=e.pos
						else :
							pos5_2=e.pos + len(e.seq)
						#print pos5_1,pos5_2
						tmpstr=""
						tmpstr=tmpstr+a.name+"\t"
						tmpstr=tmpstr+(str(e.strand*0x20+d.strand*0x10+(a.flag & 0x7CF))+"\t")
						tmpstr=tmpstr+(d.chr+"\t")
						tmpstr=tmpstr+(str(d.pos)+"\t")
						tmpstr=tmpstr+("0\t")
						tmpstr=tmpstr+(d.cigar+"\t")
						tmpstr=tmpstr+("=\t")
						tmpstr=tmpstr+(str(e.pos)+"\t")
						tmpstr=tmpstr+(str(pos5_2-pos5_1)+"\t")
						tmpstr=tmpstr+(a.seq+"\t")
						tmpstr=tmpstr+(a.qval+"\n")
						buffer.append(tmpstr)
						
						tmpstr=""
						tmpstr=tmpstr+(b.name+"\t")
        		                        tmpstr=tmpstr+(str(d.strand*0x20+e.strand*0x10+(b.flag & 0x7CF))+"\t")
                		                tmpstr=tmpstr+(e.chr+"\t")
                        		        tmpstr=tmpstr+(str(e.pos)+"\t")
	                        	        tmpstr=tmpstr+("0\t")
	        	                        tmpstr=tmpstr+(e.cigar+"\t")
        		       	                tmpstr=tmpstr+("=\t")
                        		        tmpstr=tmpstr+(str(d.pos)+"\t")
                                		tmpstr=tmpstr+(str(pos5_1-pos5_2)+"\t")
	                                	tmpstr=tmpstr+(b.seq+"\t")
	        	                        tmpstr=tmpstr+(b.qval+"\n")				
						buffer.append(tmpstr)
			
			if is_con:
				break
			
		if not is_con:
			for i in range(0,len(buffer)):
				fout.write(buffer[i])
		#else:
			#print d.name, "is concordant:", 
		mate1_list=[]
		mate2_list=[]
		#print "mate2"
		#for i in range(0,len(mate2_list)):		
		#	print mate2_list[i].pos


if __name__=='__main__':
	if len(sys.argv)!=4:
		usage()
		sys.exit(1)
	### bwa output sam file ###
	file1=sys.argv[1]
	### out put file ###
	file_out=sys.argv[2]
	### the min length of mapping distance of a discordant pair, only for opp-in pairs ###
	concordant_thresh=string.atoi(sys.argv[3])
	print file_out
	extend_XA(file1,file_out,concordant_thresh)
