#!/usr/bin/python
#######################################################################################
# Keep the best aligned read for multiple aligned reads and remove others.
#######################################################################################
import string
import sys

class sam:
	def __init__(self):
		self.sam_line=""
		self.name=""
		self.flag=0
		self.strand=0
		self.unmap=0
		self.chr=""
		self.pos=0
		self.mapq=0
		self.cigar=""
		self.mchr=""
		self.mpos=0
		self.isize=0
		self.seq=""
		self.qval=""
		self.XA=""
		self.AS=0
def usage():
	print "%s sam file" % sys.argv[0]
def get_as(line):
	pos1=line.find('AS')
	if pos1>0:
		pos2=line[pos1:].find('\t')
		as1=string.atoi(line[pos1+5:pos1+pos2]);
		return as1
	else:
		print "No AS field in sam file." 
		print line
		sys.exit(1)	
	
def rm_multi_read(filename):
	f1=open(filename,'r')
	fout=open(filename+"_rmmul","w")
    	
	line1 = f1.readline()
	while True:
		if line1[0:1]=='@':
			continue
    		if len(line1) == 0: # Zero length indicates EOF
        		break
		tmp1=line1.split()
		as1=get_as(line1)
		while True:
			line2 = f1.readline()
			if len(line2) == 0: # Zero length indicates EOF
				fout.write(line1)
				line1=line2	
	                        break
			tmp2 = line2.split()
			if (tmp1[0]==tmp2[0]):
				as2=get_as(line2)
				if as2 > as1:
					line1=line2
					as1=as2
	
			else:
				fout.write(line1)
				line1=line2
				break
		


if __name__=='__main__':
	if len(sys.argv)!=2:
		usage()
		sys.exit(1)
	file1=sys.argv[1]
	rm_multi_read(file1)
